# Return hotel rules (reference payload).

Hotel Rules retrieves the rules associated with a specific rate. The reference payload references an offer by sending the unique offer ID from an Availability response, instead of sending all required offer details as in the full payload Rules request. The response for both the reference and full payload is the same.

Endpoint: POST /hotel/rules/offershospitality/buildfromcatalogoffering
Version: 11.36.0
Security: bearerAuth

## Security:

  - `bearerAuth` (unknown)
    http bearer JWT

## Header parameters:

  - `TraceId` (string)
    Used in hospitality workflows to provide a Unique transaction or tracking id for a single request and response.

  - `XAUTH_TRAVELPORT_ACCESSGROUP` (string)
    Identifies the Travelport access group with which the caller is associated

  - `TVP-PCC-Core` (string)
    Allows user to pass PCC instead of Access Group ID

  - `TVP-Correlation-Id` (string)
    Identifier used to correlate hotel API invocations across a multi-call business flows.

## Request fields (application/json):

  - `OfferQueryBuildFromCatalogOffering` (object)
    Used for a Hotel Rules (Reference Payload) request. Defines a request to retrieve the rules associated with a specific rate by referencing a selected offer from a preceding Hotel Availability response. This request is typically sent directly after Hotel Availability and before booking. If the cached offer expires, a new Hotel Availability request must be sent.

  - `OfferQueryBuildFromCatalogOffering.@type` (string, required)
    Discriminator class OfferQueryBuildFromCatalogOffering only
    Example: OfferQueryBuildFromCatalogOffering

  - `OfferQueryBuildFromCatalogOffering.BuildFromCatalogOfferingHospitality` (object)
    For a Rules (Reference Payload) or a Create Reservation (Reference Payload) call, reference the value returned in the Availability response at CatalogOffering/id for the specific offer you want to request. Send this value in CatalogOfferingIdentifier. Offers from an Availability response are stored in cache for 30 minutes. If the offers expire you must send a new Availability request.

  - `OfferQueryBuildFromCatalogOffering.BuildFromCatalogOfferingHospitality.@type` (string)
    Example: BuildFromCatalogOfferingHospitality

  - `OfferQueryBuildFromCatalogOffering.BuildFromCatalogOfferingHospitality.CatalogOfferingIdentifier` (object)
    A globally unique identifier key often used to reference a given option (such as Pricing, Booking, Rules, or additional workflows) or to retrieve information (such as Hotel pagination).

  - `OfferQueryBuildFromCatalogOffering.BuildFromCatalogOfferingHospitality.CatalogOfferingIdentifier.value` (string)
    Unique offer identifier that can be sent in subsequent payload requests to reference this offer.
When used for reference flight calls, the CatalogProductOfferingsIdentifier will be the transaction identifier from the Search, Next Leg Search, or Flight Specific Search response in CatalogProductOfferings/Identifier/value.
If you choose to pull the CatalogProductOfferingsIdentifier from the Price response instead (OfferListResponse/Identifier/value), either full or reference payload, please note for subsequent Add Offer requests you must remove the _PC appended to the end of the value in the AirPrice response (e.g., change value: '93d2091d-3d04-48ab-8091-6ae1525f02ea_PC' to value: '93d2091d-3d04-48ab-8091-6ae1525f02ea').
When building an AirPrice or Add Offer reference payload request:
- Look for the CatalogProductOfferingIdentifier (ex: o1) in a Search response at CatalogProductOfferings/CatalogProductOffering/id or a Price response at OfferListResponse/OfferID/id.
- Look for the ProductIdentifier (ex: p0) in a Search response at CatalogProductOfferings/CatalogProductOffering/ProductBrandOptions/ProductBrandOffering/Product/productRef or from a Price response at OfferListResponse/OfferID/Product/id.

When returned from a workbench, this value is the system generated workbench identifier that must be sent in all subsequent requests for this workbench session.
When returned from Air Exchange Eligibility, value is the ticket number sent with the eligibility request.
When used specifically for form of payment, the value will begin with the characters 'FOP'. Similarly, the OfferIdentifier associated will begin with the character 'O'.
- If not available, for Payment, any unique identifier can be sent.

For Hotel Create Reservation (Reference Payload), send the value from the Availability response in CatalogOffering/id or the value from SearchComplete returned in propertyItems/lowestPublicAvailableRate/rateKey/value.
Results from Hotel Availability and Hotel SearchComplete are stored in the cache for 30 minutes. If the offers expire before booking, you must send a new request.
    Example: A0656EFF-FAF4-456F-B061-0161008D7C4E

  - `OfferQueryBuildFromCatalogOffering.BuildFromCatalogOfferingHospitality.CatalogOfferingIdentifier.authority` (string)
    Name of the supplier system that created this identifier - the source of information.  
For AirPrice, please note that GDS offers return the value 'Travelport' in authority while NDC offers return the carrier code of the issuing NDC carrier.  
When returned from Air Exchange Eligibility, authority is always 'Travelport' as the transaction issuer.  
For Hotels, authority indicates which supplier returned the lowest available rate for that property: either 'TVPT' (Travelport) or 'BKNG' (booking.com). Booking.com access requires additional provisioning and a direct agreement with the supplier. Authority is not returned if the property is closed or returns an error.  
For Hotel Create Reservation (Full Payload) and Sync Reservation send the value from the Availability response in CatalogOffering/Identifier/authority for the instance you want to book.
    Example: TVPT

  - `OfferQueryBuildFromCatalogOffering.BuildFromCatalogOfferingHospitality.SpecialInstruction` (string)
    Customer generated special instructions transmitted to the hotel.
    Example: Guest prefers room on first floor.

  - `OfferQueryBuildFromCatalogOffering.BuildFromCatalogOfferingHospitality.NumberOfRooms` (integer)
    Not supported.
    Example: 1

  - `OfferQueryBuildFromCatalogOffering.BuildFromCatalogOfferingHospitality.RoomPerTravelerInd` (boolean)
    Not implemented.

## Request examples:

  - `Rules reference payload` (unknown)

## Response 200:

  - `200` (unknown)
    OK - Successful Response - 200

## Response 200 fields (application/json):

  - `OfferHospitalityResponse` (object)
    The response of a Hotel Rules (Reference Payload) or Hotel Rules (Full Payload) endpoint request.

  - `OfferHospitalityResponse.@type` (string)
    Example: response

  - `OfferHospitalityResponse.transactionId` (string)
    A unique system-generated (128 bit GUID format) transaction/tracking id for a single request and response (i.e. for a single transaction) used for internal tracking and troubleshooting.  
Also known as E2ETrackingId.  
Not returned in all Hotel API responses.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `OfferHospitalityResponse.traceId` (string)
    Used in hospitality workflows to provide a unique transaction or tracking id for a single request and response.  
For Air Eligibility, returned if a custom trace ID was sent in the request header.  
For Hotel Rules, returned if a custom trace ID was sent in the request header.
    Example: TraceID_123456

  - `OfferHospitalityResponse.correlationId` (string)
    Identifier used to correlate hotel API invocations across a multi-call business flows.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `OfferHospitalityResponse.reservationStatus` (string)
    Status of reservation or offer completion.
    Enum: "Success", "Fail", "Partial", "Pending", "OnHold", "Retry", "Other"

  - `OfferHospitalityResponse.Result` (object)
    Returns the error and/or warning message information, if applicable.
See [Error Messaging](https://developer.travelport.com/docs/flights/general/error-messaging) for additional details.

  - `OfferHospitalityResponse.Result.@type` (string)
    Discriminator class Result only
    Example: Result

  - `OfferHospitalityResponse.Result.status` (string)
    The status of an error or warning
    Enum: "Not processed", "Incomplete", "Complete", "Unknown"

  - `OfferHospitalityResponse.Result.Error` (array)
    A list of error information returned at the provider level for a response.

  - `OfferHospitalityResponse.Result.Error.@type` (string, required)
    Discriminator classes Error or ErrorDetail
    Example: ErrorDetail

  - `OfferHospitalityResponse.Result.Error.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `OfferHospitalityResponse.Result.Error.Message` (string)
    The Travelport standardized error or warning message
    Example: No flights found.

  - `OfferHospitalityResponse.Result.Error.NameValuePair` (array)

  - `OfferHospitalityResponse.Result.Error.NameValuePair.value` (string)
    Text directly related to name description, providing more detail. May have character restrictions based on remark type (e.g. Free Text limitations: 84 characters, alphanumeric and some special characters).
    Example: Sunday

  - `OfferHospitalityResponse.Result.Error.NameValuePair.id` (string)
    Optional internally referenced id
    Example: 6

  - `OfferHospitalityResponse.Result.Error.NameValuePair.name` (string, required)
    Key, categorizing the type of remark or error.
    Example: Day1

  - `OfferHospitalityResponse.Result.Error.category` (string)
    A category to assist in identifying the error
    Example: VALIDATION

  - `OfferHospitalityResponse.Result.Error.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `OfferHospitalityResponse.Result.Error.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `OfferHospitalityResponse.Result.Error.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `OfferHospitalityResponse.Result.Warning` (array)
    A list of warning information returned at the provider level for a response.

  - `OfferHospitalityResponse.Result.Warning.@type` (string, required)
    Discriminator classes Warning or WarningDetail
    Example: WarningDetail

  - `OfferHospitalityResponse.Result.Warning.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `OfferHospitalityResponse.Result.Warning.Message` (string)
    The Travelport standardized error or warning message
    Example: Customer Loyalty could not be applied.

  - `OfferHospitalityResponse.Result.Warning.NameValuePair` (array)

  - `OfferHospitalityResponse.Result.Warning.category` (string)
    A category to assist in identifying the error
    Example: INFORMATION

  - `OfferHospitalityResponse.Result.Warning.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `OfferHospitalityResponse.Result.Warning.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `OfferHospitalityResponse.Result.Warning.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `OfferHospitalityResponse.Identifier` (object)
    A globally unique identifier key often used to reference a given option (such as Pricing, Booking, Rules, or additional workflows) or to retrieve information (such as Hotel pagination).

  - `OfferHospitalityResponse.Identifier.value` (string)
    Unique offer identifier that can be sent in subsequent payload requests to reference this offer.
When used for reference flight calls, the CatalogProductOfferingsIdentifier will be the transaction identifier from the Search, Next Leg Search, or Flight Specific Search response in CatalogProductOfferings/Identifier/value.
If you choose to pull the CatalogProductOfferingsIdentifier from the Price response instead (OfferListResponse/Identifier/value), either full or reference payload, please note for subsequent Add Offer requests you must remove the _PC appended to the end of the value in the AirPrice response (e.g., change value: '93d2091d-3d04-48ab-8091-6ae1525f02ea_PC' to value: '93d2091d-3d04-48ab-8091-6ae1525f02ea').
When building an AirPrice or Add Offer reference payload request:
- Look for the CatalogProductOfferingIdentifier (ex: o1) in a Search response at CatalogProductOfferings/CatalogProductOffering/id or a Price response at OfferListResponse/OfferID/id.
- Look for the ProductIdentifier (ex: p0) in a Search response at CatalogProductOfferings/CatalogProductOffering/ProductBrandOptions/ProductBrandOffering/Product/productRef or from a Price response at OfferListResponse/OfferID/Product/id.

When returned from a workbench, this value is the system generated workbench identifier that must be sent in all subsequent requests for this workbench session.
When returned from Air Exchange Eligibility, value is the ticket number sent with the eligibility request.
When used specifically for form of payment, the value will begin with the characters 'FOP'. Similarly, the OfferIdentifier associated will begin with the character 'O'.
- If not available, for Payment, any unique identifier can be sent.

For Hotel Create Reservation (Reference Payload), send the value from the Availability response in CatalogOffering/id or the value from SearchComplete returned in propertyItems/lowestPublicAvailableRate/rateKey/value.
Results from Hotel Availability and Hotel SearchComplete are stored in the cache for 30 minutes. If the offers expire before booking, you must send a new request.
    Example: A0656EFF-FAF4-456F-B061-0161008D7C4E

  - `OfferHospitalityResponse.Identifier.authority` (string)
    Name of the supplier system that created this identifier - the source of information.  
For AirPrice, please note that GDS offers return the value 'Travelport' in authority while NDC offers return the carrier code of the issuing NDC carrier.  
When returned from Air Exchange Eligibility, authority is always 'Travelport' as the transaction issuer.  
For Hotels, authority indicates which supplier returned the lowest available rate for that property: either 'TVPT' (Travelport) or 'BKNG' (booking.com). Booking.com access requires additional provisioning and a direct agreement with the supplier. Authority is not returned if the property is closed or returns an error.  
For Hotel Create Reservation (Full Payload) and Sync Reservation send the value from the Availability response in CatalogOffering/Identifier/authority for the instance you want to book.
    Example: TVPT

  - `OfferHospitalityResponse.NextSteps` (object)
    Container for the steps that describe actions that may be taken on the containing object.  
Not applicable for an Eligibility or Exchange response.

  - `OfferHospitalityResponse.NextSteps.baseURI` (string, required)
    The base portion of the URI in order to shorten the uris in the individual steps
    Example: www.travelport.com

  - `OfferHospitalityResponse.NextSteps.id` (string)
    Optional internally referenced id
    Example: 5

  - `OfferHospitalityResponse.NextSteps.NextStep` (array, required)

  - `OfferHospitalityResponse.NextSteps.NextStep.value` (string)
    Example: www.resourcelocation.com

  - `OfferHospitalityResponse.NextSteps.NextStep.id` (string)
    Identifier for the Next Step
    Example: 2

  - `OfferHospitalityResponse.NextSteps.NextStep.action` (string, required)
    The action this next step is intended to achieve
    Example: cancel

  - `OfferHospitalityResponse.NextSteps.NextStep.method` (string, required)
    Describes the set of potential methods that can be taken after an operation.
    Enum: "GET", "DELETE", "PUT", "POST"

  - `OfferHospitalityResponse.NextSteps.NextStep.description` (string)
    Additional clarification for the next step
    Example: remove offer from the order

  - `OfferHospitalityResponse.ReferenceList` (array)

  - `OfferHospitalityResponse.ReferenceList.@type` (string, required)
    Discriminator
- Air Search child classes are ReferenceListAmenity, ReferenceListBrand, ReferenceListFlight, ReferenceListProduct, ReferenceListTermsAndConditions, and ReferenceListUniversalProductAttribute.
- Air Price child classes are ReferenceListAmenity and ReferenceListBrand.
- FareRules child class is ReferenceListFlight.
- Search Ancillaries child class is ReferenceListFlight.
- Seat Map child class is ReferenceListSeatingChart.
- Hotel Availability child class is ReferenceListPropertyDates.
- Reservation and Reservation Workbench child classes are ReferenceListAmenity, ReferenceListBrand, and ReferenceListUniversalProductAttribute.
- Exchange Search child classes are ReferenceListBrand, ReferenceListFlight, and ReferenceListExchangedPrice.
- Reservation Receipt child classes are ReferenceListOffer and ReferenceListTraveler.
- Book_Traveler child class is ReferenceListTraveler.
    Example: ReferenceListFlight

  - `OfferHospitalityResponse.ReferenceList.id` (string)
    Uniquely identifies for the Reference List
    Example: referenceList_001

  - `OfferHospitalityResponse.ReferenceList.PropertyDates` (array, required)

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.@type` (string)

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.availability` (string)
    Indicates whether the property has rooms available for the requested dates.
    Enum: "Open", "Close", "ClosedOnArrival", "ClosedOnArrivalOnRequest", "OnRequest", "RemoveCloseOnly", "Other"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.adaCompliant` (string)
    Yes , No , Unknown
    Enum: "Yes", "No", "Unknown"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.id` (string, required)
    Key to matching the common information in ReferenceList with an Offer; corresponds to the propertyDatesRef value in each Offer/Products/Product.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.moreRatesToken` (string)
    More rates token

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.propertyName` (string)
    Name of property offering these products.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress` (object)
    The property or billing address information.  
For Flights Add Traveler sending Address is optional, but when sent it must have the role set to 'Delivery' and include at least one of its objects, such as Number or City.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.@type` (string, required)
    Discriminator classes Address or AddressDetail
    Example: AddressDetail

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.id` (string)
    unique address id
    Example: Address_1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.BldgRoom` (object)
    Address with building and room number

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.BldgRoom.value` (string)
    Example: Moore House

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.BldgRoom.buldingInd` (boolean)
    When true, the information is a building name. When false, it is an apartment or room #
    Example: true

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number` (object)
    The street number alone is the numerical number that precedes the street name in the address.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.value` (string)
    Street number value.
    Example: 23B

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.streetNmbrSuffix` (string)
    Street Number Suffix
    Example: B

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.streetDirection` (string)
    Direction of the Street
    Example: NW

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.ruralRouteNmbr` (string)
    RuralRoute Number
    Example: 76

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.po_Box` (string)
    PO Box Number
    Example: 1001

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Street` (string)
    Street name. May also contain the street number when the Number element is missing.
    Example: ABC Street

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.AddressLine` (array)
    Property street address. Used in place of Street and Number. Each element of the array represents an address line.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.City` (string, required)
    Full name of the city, town, or postal station (i.e., a postal service territory, often used in a military address).
    Example: Dublin

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.County` (string)
    County or Region Name.
    Example: Berkshire

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.StateProv` (object)
    The standard code or abbreviation for the state, province, or region. May also include full length name.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.StateProv.value` (string)
    State, province, or region code needed to identify location (typically two characters).
    Example: CA

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.StateProv.name` (string)
    State, province, or region name needed to identify location.
    Example: California

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country` (object)
    Contains the information needed to identify a country.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country.value` (string)
    The ISO 3166 code for the property's address.
    Example: US

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country.id` (string)
    Custom user-assigned identifier for the country.
    Example: 23

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country.name` (string)
    The full name of the country for the property's address.
    Example: United States

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country.codeContext` (string)
    The source of a code, such as the organization that provided the id number
    Example: IATA

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.PostalCode` (string)
    Postal code for the address.
    Example: Sl6 1AB

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Addressee` (string)
    The name of the company or person to be addressed
    Example: ACME INC

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.role` (string)
    Defines the type of location the address is assigned to. For TravelAgency address leave blank or use "Other".
    Enum: "Home", "Business", "Mailing", "Delivery", "Destination", "Other", "Billing"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.addressType` (string)
    OTA code for address type
    Example: CLT

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.use` (string)
    OTA code for address use
    Example: AUT

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment` (object)
    Textual information.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment.value` (string)
    Actual text.
May be restricted based on the type of comment. Ex:
- Notepad remarks: limited to 87 characters.
- Traveler name remarks: limited to 33 characters, only spaces and hyphens allowed for special characters.
    Example: Additional comments

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment.id` (string)
    Local identifier within a given message for this object.
    Example: comment_1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment.name` (string)
    Title of comment or type of remark.
    Example: Comment name

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment.language` (string)
    Language code using ISO-639 standard
    Example: EN

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy` (object)
    Confidential details for marketing purpose

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.id` (string)
    Optional internally referenced id
    Example: 2

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.shareMarketing` (string)
    Used to indicate marketing preferences, Yes, No, Inherit
    Enum: "Yes", "No", "Inherit"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.optInStatus` (string)
    Used to indicate marketing preferences, OptIn, OptOut
    Enum: "OptedIn", "OptedOut", "Unknown"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.optInDate` (string)
    The datetime of receiving the opt in notice
    Example: 2026-08-07T12:12:00Z

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.optOutDate` (string)
    The datetime the opt out notice was received
    Example: 2026-08-07T12:12:00Z

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Priority` (integer)
    The priority ranking within the group
    Example: 1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.validInd` (boolean)
    If true, this is a valid and complete mailing address that has been verified through an address verification service or previously mailed materials have not been returned.
    Example: false

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.provisionedInd` (boolean)
    If true, this address came into the system through provisioning
    Example: false

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyKey` (object, required)
    Contains up to 250 PropertyKey objects. Each PropertyKey object identifies one property.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyKey.@type` (string)

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyKey.chainCode` (string, required)
    Code for the hotel chain (typically 2 characters)
    Example: UR

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyKey.propertyCode` (string, required)
    The property code of the requested property (typically 5 characters).
    Example: G3375

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.DateRange` (object, required)
    Specifies the begin and end date of an event, such as check-in and check-out dates.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.DateRange.start` (string, required)
    Specifies the start date for an event, such as a booking or check-in date in YYYY-MM-DD format.
    Example: 2026-03-03

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.DateRange.end` (string, required)
    Specifies the end date an event, such as a booking or check-out date in YYYY-MM-DD format.
    Example: 2026-03-03

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation` (object)
    For Hotel: the geographic coordinates of the property.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.latitude` (number, required)
    Numeric value representing latitude of search center point in degrees and decimal minutes.
    Example: 38.8951

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.longitude` (number, required)
    Numeric value representing longitude of search center point in degrees and decimal minutes.
    Example: -77.0364

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.altitude` (number)
    The height of a location, typically measured above sea level
    Example: 5280

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.altitudeUnitOfDistance` (string)
    For Hotels: Optional object to request either miles or kilometers for the search radius from the specified location. If unitOfDistance is not specified, the search defaults to miles for properties in the United States, Myanmar, and Liberia. The search defaults to kilometers in all other countries.
    Enum: "Miles", "Kilometers"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.positionAccuracy` (string)
    Specifies the level of accuracy for the position
    Enum: "Zip9Code", "Zip7Code", "Zip5Code", "Street", "State", "Property", "Intersection", "Exact", "County", "City", "Block"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.mapURL` (string)
    link for embedded map showing location
    Example: www.destinationmap.com

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.formatURL` (string)
    The URL to the format for the latitude and longitude for this location.
    Example: www.destinationmap.com

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone` (object)
    Phone information for contacting the relevant individual or agency.  
For Flights Add Traveler, NDC carriers typically require either an email address or phone number for booking. Recommended best practice is to provide both Email and Telephone for NDC.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.@type` (string, required)
    Discriminator classes Telephone or TelephoneDetail
    Example: Telephone

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.countryAccessCode` (string)
    Phone country code
    Example: 1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.areaCityCode` (string)
    Phone local area code
    Example: 972

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.phoneNumber` (string, required)
    Mobile/Telephone Number. Accepted characters are numeric, dash, space, and period.
    Example: 972-000-787

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.extension` (string)
    Telephone extension number
    Example: 234

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.id` (string)
    Optional custom user-assigned identifier for a phone number.
    Example: 3

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.cityCode` (string)
    IATA city code if referenced by phone number.
    Example: DEN

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.role` (string)
    Defines the type of location the Telephone is assigned to. For Travel Agency telephone select "Other" or leave blank.
    Enum: "Mobile", "Home", "Work", "Office", "Fax", "Other"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.phoneLocationType` (string)
    Location of the phone
    Example: Agency

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.phoneTechType` (string)
    Indicates the type of technology associated with the telephone number
    Example: Voice

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.phoneUseType` (string)
    Agency code for how phone is used (e.g., Home, Business, Emergency Contact, Travel Arranger, Day, Evening).
    Example: Home

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.pin` (string)
    Additional codes used for telephone
    Example: 3456

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.priority` (integer)
    Priority
    Example: 1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.defaultInd` (boolean)
    When true, indicates a default value should be used.
    Example: true

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.provisionedInd` (boolean)
    true indicates this phone number was created through provisioned
    Example: false

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email` (object)
    Electronic email addresses, in IETF specified format.  
Booking.com requires a traveler email address in the Hotel Create Reservation and Add Reservation requests. A system-generated confirmation email is sent to the traveler after the booking completes.
For Flights Add Traveler, NDC carriers typically require either an email address or phone number for booking. Recommended best practice is to provide both Email and Telephone for NDC.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.value` (string)
    The email address.
    Example: exampledomain@example.com

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.id` (string)
    Electronic email addresses, in IETF specified format.
    Example: email_1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.emailType` (string)
    Use email type to specify if the email is to be sent "TO" or sent "FROM"
    Example: FROM

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.comment` (string)
    Any freeform note for the email, such as its purpose.
    Example: work email

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.preferredFormat` (string)
    Mime media type
    Example: text/html

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.optInDate` (string)
    The datetime of receiving the opt in notice
    Example: 2026-03-03T11:11:00Z

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.optOutDate` (string)
    The datetime the opt out notice was received
    Example: 2026-03-03T11:11:00Z

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.validInd` (boolean)
    If true, this is a valid email address that has been system verified via a successful email transmission.
    Example: true

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.provisionedInd` (boolean)
    If true then the email address came from the provisioning process
    Example: true

  - `OfferHospitalityResponse.CurrencyRateConversion` (array)

  - `OfferHospitalityResponse.CurrencyRateConversion.@type` (string)

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency` (object, required)
    Currency codes are the three-letter alphabetic codes that represent the various currencies used throughout the world.  
Unless changed in the request, the currency is the default associated with your provisioned PCC from Travelport.  
For Hotel: SourceCurrency is based on the location of the hotel and used for all rates in the response. TargetCurrency is the currency code sent in the request in requestedCurrency.

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency.value` (string)
    An ISO 4217 currency code.
    Example: USD

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency.codeAuthority` (string)
    Currency code authority
    Example: ISO 4217

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency.decimalPlace` (integer)
    Number of decimal places for the currency.
    Example: 2

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency.decimalAuthority` (string)
    Currency code decimal authority
    Example: ISO 4217

  - `OfferHospitalityResponse.CurrencyRateConversion.ConversionRate` (object, required)
    Conversion rate of SourceCurrency value to TargetCurrency value. This value can be used to calculate, independently of the API, conversion for the rates in the response. The response does not convert any amounts.

  - `OfferHospitalityResponse.CurrencyRateConversion.ConversionRate.value` (number)

  - `OfferHospitalityResponse.CurrencyRateConversion.ConversionRate.rateAuthority` (string)
    Contextual rate authority
    Example: ISO 4217

  - `OfferHospitalityResponse.CurrencyRateConversion.ConversionRate.rateAsOf` (string)
    Rate as of
    Example: 2026-08-07T12:12:00Z

  - `OfferHospitalityResponse.Pagination` (object)
    Pagination object used when result sets span across a number of pages.

  - `OfferHospitalityResponse.Pagination.@type` (string, required)
    Example: Pagination

  - `OfferHospitalityResponse.Pagination.page` (integer, required)
    The current page number of the full result set
    Example: 1

  - `OfferHospitalityResponse.Pagination.pageSize` (integer, required)
    The total number of items on this page
    Example: 20

  - `OfferHospitalityResponse.Pagination.totalPages` (integer, required)
    The total number of pages in this result set
    Example: 5

  - `OfferHospitalityResponse.Pagination.totalItems` (integer, required)
    The total number of pages in this result set
    Example: 100

## Response 201:

  - `201` (unknown)
    Created - 201

## Response 201 fields (application/json):

  - `OfferHospitalityResponse` (object)
    The response of a Hotel Rules (Reference Payload) or Hotel Rules (Full Payload) endpoint request.

  - `OfferHospitalityResponse.@type` (string)
    Example: response

  - `OfferHospitalityResponse.transactionId` (string)
    A unique system-generated (128 bit GUID format) transaction/tracking id for a single request and response (i.e. for a single transaction) used for internal tracking and troubleshooting.  
Also known as E2ETrackingId.  
Not returned in all Hotel API responses.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `OfferHospitalityResponse.traceId` (string)
    Used in hospitality workflows to provide a unique transaction or tracking id for a single request and response.  
For Air Eligibility, returned if a custom trace ID was sent in the request header.  
For Hotel Rules, returned if a custom trace ID was sent in the request header.
    Example: TraceID_123456

  - `OfferHospitalityResponse.correlationId` (string)
    Identifier used to correlate hotel API invocations across a multi-call business flows.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `OfferHospitalityResponse.reservationStatus` (string)
    Status of reservation or offer completion.
    Enum: "Success", "Fail", "Partial", "Pending", "OnHold", "Retry", "Other"

  - `OfferHospitalityResponse.Result` (object)
    Returns the error and/or warning message information, if applicable.
See [Error Messaging](https://developer.travelport.com/docs/flights/general/error-messaging) for additional details.

  - `OfferHospitalityResponse.Result.@type` (string)
    Discriminator class Result only
    Example: Result

  - `OfferHospitalityResponse.Result.status` (string)
    The status of an error or warning
    Enum: "Not processed", "Incomplete", "Complete", "Unknown"

  - `OfferHospitalityResponse.Result.Error` (array)
    A list of error information returned at the provider level for a response.

  - `OfferHospitalityResponse.Result.Error.@type` (string, required)
    Discriminator classes Error or ErrorDetail
    Example: ErrorDetail

  - `OfferHospitalityResponse.Result.Error.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `OfferHospitalityResponse.Result.Error.Message` (string)
    The Travelport standardized error or warning message
    Example: No flights found.

  - `OfferHospitalityResponse.Result.Error.NameValuePair` (array)

  - `OfferHospitalityResponse.Result.Error.NameValuePair.value` (string)
    Text directly related to name description, providing more detail. May have character restrictions based on remark type (e.g. Free Text limitations: 84 characters, alphanumeric and some special characters).
    Example: Sunday

  - `OfferHospitalityResponse.Result.Error.NameValuePair.id` (string)
    Optional internally referenced id
    Example: 6

  - `OfferHospitalityResponse.Result.Error.NameValuePair.name` (string, required)
    Key, categorizing the type of remark or error.
    Example: Day1

  - `OfferHospitalityResponse.Result.Error.category` (string)
    A category to assist in identifying the error
    Example: VALIDATION

  - `OfferHospitalityResponse.Result.Error.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `OfferHospitalityResponse.Result.Error.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `OfferHospitalityResponse.Result.Error.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `OfferHospitalityResponse.Result.Warning` (array)
    A list of warning information returned at the provider level for a response.

  - `OfferHospitalityResponse.Result.Warning.@type` (string, required)
    Discriminator classes Warning or WarningDetail
    Example: WarningDetail

  - `OfferHospitalityResponse.Result.Warning.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `OfferHospitalityResponse.Result.Warning.Message` (string)
    The Travelport standardized error or warning message
    Example: Customer Loyalty could not be applied.

  - `OfferHospitalityResponse.Result.Warning.NameValuePair` (array)

  - `OfferHospitalityResponse.Result.Warning.category` (string)
    A category to assist in identifying the error
    Example: INFORMATION

  - `OfferHospitalityResponse.Result.Warning.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `OfferHospitalityResponse.Result.Warning.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `OfferHospitalityResponse.Result.Warning.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `OfferHospitalityResponse.Identifier` (object)
    A globally unique identifier key often used to reference a given option (such as Pricing, Booking, Rules, or additional workflows) or to retrieve information (such as Hotel pagination).

  - `OfferHospitalityResponse.Identifier.value` (string)
    Unique offer identifier that can be sent in subsequent payload requests to reference this offer.
When used for reference flight calls, the CatalogProductOfferingsIdentifier will be the transaction identifier from the Search, Next Leg Search, or Flight Specific Search response in CatalogProductOfferings/Identifier/value.
If you choose to pull the CatalogProductOfferingsIdentifier from the Price response instead (OfferListResponse/Identifier/value), either full or reference payload, please note for subsequent Add Offer requests you must remove the _PC appended to the end of the value in the AirPrice response (e.g., change value: '93d2091d-3d04-48ab-8091-6ae1525f02ea_PC' to value: '93d2091d-3d04-48ab-8091-6ae1525f02ea').
When building an AirPrice or Add Offer reference payload request:
- Look for the CatalogProductOfferingIdentifier (ex: o1) in a Search response at CatalogProductOfferings/CatalogProductOffering/id or a Price response at OfferListResponse/OfferID/id.
- Look for the ProductIdentifier (ex: p0) in a Search response at CatalogProductOfferings/CatalogProductOffering/ProductBrandOptions/ProductBrandOffering/Product/productRef or from a Price response at OfferListResponse/OfferID/Product/id.

When returned from a workbench, this value is the system generated workbench identifier that must be sent in all subsequent requests for this workbench session.
When returned from Air Exchange Eligibility, value is the ticket number sent with the eligibility request.
When used specifically for form of payment, the value will begin with the characters 'FOP'. Similarly, the OfferIdentifier associated will begin with the character 'O'.
- If not available, for Payment, any unique identifier can be sent.

For Hotel Create Reservation (Reference Payload), send the value from the Availability response in CatalogOffering/id or the value from SearchComplete returned in propertyItems/lowestPublicAvailableRate/rateKey/value.
Results from Hotel Availability and Hotel SearchComplete are stored in the cache for 30 minutes. If the offers expire before booking, you must send a new request.
    Example: A0656EFF-FAF4-456F-B061-0161008D7C4E

  - `OfferHospitalityResponse.Identifier.authority` (string)
    Name of the supplier system that created this identifier - the source of information.  
For AirPrice, please note that GDS offers return the value 'Travelport' in authority while NDC offers return the carrier code of the issuing NDC carrier.  
When returned from Air Exchange Eligibility, authority is always 'Travelport' as the transaction issuer.  
For Hotels, authority indicates which supplier returned the lowest available rate for that property: either 'TVPT' (Travelport) or 'BKNG' (booking.com). Booking.com access requires additional provisioning and a direct agreement with the supplier. Authority is not returned if the property is closed or returns an error.  
For Hotel Create Reservation (Full Payload) and Sync Reservation send the value from the Availability response in CatalogOffering/Identifier/authority for the instance you want to book.
    Example: TVPT

  - `OfferHospitalityResponse.NextSteps` (object)
    Container for the steps that describe actions that may be taken on the containing object.  
Not applicable for an Eligibility or Exchange response.

  - `OfferHospitalityResponse.NextSteps.baseURI` (string, required)
    The base portion of the URI in order to shorten the uris in the individual steps
    Example: www.travelport.com

  - `OfferHospitalityResponse.NextSteps.id` (string)
    Optional internally referenced id
    Example: 5

  - `OfferHospitalityResponse.NextSteps.NextStep` (array, required)

  - `OfferHospitalityResponse.NextSteps.NextStep.value` (string)
    Example: www.resourcelocation.com

  - `OfferHospitalityResponse.NextSteps.NextStep.id` (string)
    Identifier for the Next Step
    Example: 2

  - `OfferHospitalityResponse.NextSteps.NextStep.action` (string, required)
    The action this next step is intended to achieve
    Example: cancel

  - `OfferHospitalityResponse.NextSteps.NextStep.method` (string, required)
    Describes the set of potential methods that can be taken after an operation.
    Enum: "GET", "DELETE", "PUT", "POST"

  - `OfferHospitalityResponse.NextSteps.NextStep.description` (string)
    Additional clarification for the next step
    Example: remove offer from the order

  - `OfferHospitalityResponse.ReferenceList` (array)

  - `OfferHospitalityResponse.ReferenceList.@type` (string, required)
    Discriminator
- Air Search child classes are ReferenceListAmenity, ReferenceListBrand, ReferenceListFlight, ReferenceListProduct, ReferenceListTermsAndConditions, and ReferenceListUniversalProductAttribute.
- Air Price child classes are ReferenceListAmenity and ReferenceListBrand.
- FareRules child class is ReferenceListFlight.
- Search Ancillaries child class is ReferenceListFlight.
- Seat Map child class is ReferenceListSeatingChart.
- Hotel Availability child class is ReferenceListPropertyDates.
- Reservation and Reservation Workbench child classes are ReferenceListAmenity, ReferenceListBrand, and ReferenceListUniversalProductAttribute.
- Exchange Search child classes are ReferenceListBrand, ReferenceListFlight, and ReferenceListExchangedPrice.
- Reservation Receipt child classes are ReferenceListOffer and ReferenceListTraveler.
- Book_Traveler child class is ReferenceListTraveler.
    Example: ReferenceListFlight

  - `OfferHospitalityResponse.ReferenceList.id` (string)
    Uniquely identifies for the Reference List
    Example: referenceList_001

  - `OfferHospitalityResponse.ReferenceList.PropertyDates` (array, required)

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.@type` (string)

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.availability` (string)
    Indicates whether the property has rooms available for the requested dates.
    Enum: "Open", "Close", "ClosedOnArrival", "ClosedOnArrivalOnRequest", "OnRequest", "RemoveCloseOnly", "Other"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.adaCompliant` (string)
    Yes , No , Unknown
    Enum: "Yes", "No", "Unknown"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.id` (string, required)
    Key to matching the common information in ReferenceList with an Offer; corresponds to the propertyDatesRef value in each Offer/Products/Product.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.moreRatesToken` (string)
    More rates token

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.propertyName` (string)
    Name of property offering these products.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress` (object)
    The property or billing address information.  
For Flights Add Traveler sending Address is optional, but when sent it must have the role set to 'Delivery' and include at least one of its objects, such as Number or City.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.@type` (string, required)
    Discriminator classes Address or AddressDetail
    Example: AddressDetail

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.id` (string)
    unique address id
    Example: Address_1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.BldgRoom` (object)
    Address with building and room number

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.BldgRoom.value` (string)
    Example: Moore House

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.BldgRoom.buldingInd` (boolean)
    When true, the information is a building name. When false, it is an apartment or room #
    Example: true

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number` (object)
    The street number alone is the numerical number that precedes the street name in the address.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.value` (string)
    Street number value.
    Example: 23B

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.streetNmbrSuffix` (string)
    Street Number Suffix
    Example: B

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.streetDirection` (string)
    Direction of the Street
    Example: NW

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.ruralRouteNmbr` (string)
    RuralRoute Number
    Example: 76

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Number.po_Box` (string)
    PO Box Number
    Example: 1001

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Street` (string)
    Street name. May also contain the street number when the Number element is missing.
    Example: ABC Street

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.AddressLine` (array)
    Property street address. Used in place of Street and Number. Each element of the array represents an address line.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.City` (string, required)
    Full name of the city, town, or postal station (i.e., a postal service territory, often used in a military address).
    Example: Dublin

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.County` (string)
    County or Region Name.
    Example: Berkshire

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.StateProv` (object)
    The standard code or abbreviation for the state, province, or region. May also include full length name.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.StateProv.value` (string)
    State, province, or region code needed to identify location (typically two characters).
    Example: CA

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.StateProv.name` (string)
    State, province, or region name needed to identify location.
    Example: California

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country` (object)
    Contains the information needed to identify a country.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country.value` (string)
    The ISO 3166 code for the property's address.
    Example: US

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country.id` (string)
    Custom user-assigned identifier for the country.
    Example: 23

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country.name` (string)
    The full name of the country for the property's address.
    Example: United States

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Country.codeContext` (string)
    The source of a code, such as the organization that provided the id number
    Example: IATA

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.PostalCode` (string)
    Postal code for the address.
    Example: Sl6 1AB

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Addressee` (string)
    The name of the company or person to be addressed
    Example: ACME INC

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.role` (string)
    Defines the type of location the address is assigned to. For TravelAgency address leave blank or use "Other".
    Enum: "Home", "Business", "Mailing", "Delivery", "Destination", "Other", "Billing"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.addressType` (string)
    OTA code for address type
    Example: CLT

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.use` (string)
    OTA code for address use
    Example: AUT

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment` (object)
    Textual information.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment.value` (string)
    Actual text.
May be restricted based on the type of comment. Ex:
- Notepad remarks: limited to 87 characters.
- Traveler name remarks: limited to 33 characters, only spaces and hyphens allowed for special characters.
    Example: Additional comments

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment.id` (string)
    Local identifier within a given message for this object.
    Example: comment_1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment.name` (string)
    Title of comment or type of remark.
    Example: Comment name

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Comment.language` (string)
    Language code using ISO-639 standard
    Example: EN

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy` (object)
    Confidential details for marketing purpose

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.id` (string)
    Optional internally referenced id
    Example: 2

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.shareMarketing` (string)
    Used to indicate marketing preferences, Yes, No, Inherit
    Enum: "Yes", "No", "Inherit"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.optInStatus` (string)
    Used to indicate marketing preferences, OptIn, OptOut
    Enum: "OptedIn", "OptedOut", "Unknown"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.optInDate` (string)
    The datetime of receiving the opt in notice
    Example: 2026-08-07T12:12:00Z

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Privacy.optOutDate` (string)
    The datetime the opt out notice was received
    Example: 2026-08-07T12:12:00Z

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.Priority` (integer)
    The priority ranking within the group
    Example: 1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.validInd` (boolean)
    If true, this is a valid and complete mailing address that has been verified through an address verification service or previously mailed materials have not been returned.
    Example: false

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyAddress.provisionedInd` (boolean)
    If true, this address came into the system through provisioning
    Example: false

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyKey` (object, required)
    Contains up to 250 PropertyKey objects. Each PropertyKey object identifies one property.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyKey.@type` (string)

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyKey.chainCode` (string, required)
    Code for the hotel chain (typically 2 characters)
    Example: UR

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.PropertyKey.propertyCode` (string, required)
    The property code of the requested property (typically 5 characters).
    Example: G3375

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.DateRange` (object, required)
    Specifies the begin and end date of an event, such as check-in and check-out dates.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.DateRange.start` (string, required)
    Specifies the start date for an event, such as a booking or check-in date in YYYY-MM-DD format.
    Example: 2026-03-03

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.DateRange.end` (string, required)
    Specifies the end date an event, such as a booking or check-out date in YYYY-MM-DD format.
    Example: 2026-03-03

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation` (object)
    For Hotel: the geographic coordinates of the property.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.latitude` (number, required)
    Numeric value representing latitude of search center point in degrees and decimal minutes.
    Example: 38.8951

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.longitude` (number, required)
    Numeric value representing longitude of search center point in degrees and decimal minutes.
    Example: -77.0364

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.altitude` (number)
    The height of a location, typically measured above sea level
    Example: 5280

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.altitudeUnitOfDistance` (string)
    For Hotels: Optional object to request either miles or kilometers for the search radius from the specified location. If unitOfDistance is not specified, the search defaults to miles for properties in the United States, Myanmar, and Liberia. The search defaults to kilometers in all other countries.
    Enum: "Miles", "Kilometers"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.positionAccuracy` (string)
    Specifies the level of accuracy for the position
    Enum: "Zip9Code", "Zip7Code", "Zip5Code", "Street", "State", "Property", "Intersection", "Exact", "County", "City", "Block"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.mapURL` (string)
    link for embedded map showing location
    Example: www.destinationmap.com

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.GeoLocation.formatURL` (string)
    The URL to the format for the latitude and longitude for this location.
    Example: www.destinationmap.com

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone` (object)
    Phone information for contacting the relevant individual or agency.  
For Flights Add Traveler, NDC carriers typically require either an email address or phone number for booking. Recommended best practice is to provide both Email and Telephone for NDC.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.@type` (string, required)
    Discriminator classes Telephone or TelephoneDetail
    Example: Telephone

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.countryAccessCode` (string)
    Phone country code
    Example: 1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.areaCityCode` (string)
    Phone local area code
    Example: 972

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.phoneNumber` (string, required)
    Mobile/Telephone Number. Accepted characters are numeric, dash, space, and period.
    Example: 972-000-787

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.extension` (string)
    Telephone extension number
    Example: 234

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.id` (string)
    Optional custom user-assigned identifier for a phone number.
    Example: 3

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.cityCode` (string)
    IATA city code if referenced by phone number.
    Example: DEN

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.role` (string)
    Defines the type of location the Telephone is assigned to. For Travel Agency telephone select "Other" or leave blank.
    Enum: "Mobile", "Home", "Work", "Office", "Fax", "Other"

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.phoneLocationType` (string)
    Location of the phone
    Example: Agency

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.phoneTechType` (string)
    Indicates the type of technology associated with the telephone number
    Example: Voice

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.phoneUseType` (string)
    Agency code for how phone is used (e.g., Home, Business, Emergency Contact, Travel Arranger, Day, Evening).
    Example: Home

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.pin` (string)
    Additional codes used for telephone
    Example: 3456

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.priority` (integer)
    Priority
    Example: 1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.defaultInd` (boolean)
    When true, indicates a default value should be used.
    Example: true

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Telephone.provisionedInd` (boolean)
    true indicates this phone number was created through provisioned
    Example: false

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email` (object)
    Electronic email addresses, in IETF specified format.  
Booking.com requires a traveler email address in the Hotel Create Reservation and Add Reservation requests. A system-generated confirmation email is sent to the traveler after the booking completes.
For Flights Add Traveler, NDC carriers typically require either an email address or phone number for booking. Recommended best practice is to provide both Email and Telephone for NDC.

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.value` (string)
    The email address.
    Example: exampledomain@example.com

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.id` (string)
    Electronic email addresses, in IETF specified format.
    Example: email_1

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.emailType` (string)
    Use email type to specify if the email is to be sent "TO" or sent "FROM"
    Example: FROM

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.comment` (string)
    Any freeform note for the email, such as its purpose.
    Example: work email

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.preferredFormat` (string)
    Mime media type
    Example: text/html

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.optInDate` (string)
    The datetime of receiving the opt in notice
    Example: 2026-03-03T11:11:00Z

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.optOutDate` (string)
    The datetime the opt out notice was received
    Example: 2026-03-03T11:11:00Z

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.validInd` (boolean)
    If true, this is a valid email address that has been system verified via a successful email transmission.
    Example: true

  - `OfferHospitalityResponse.ReferenceList.PropertyDates.Email.provisionedInd` (boolean)
    If true then the email address came from the provisioning process
    Example: true

  - `OfferHospitalityResponse.CurrencyRateConversion` (array)

  - `OfferHospitalityResponse.CurrencyRateConversion.@type` (string)

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency` (object, required)
    Currency codes are the three-letter alphabetic codes that represent the various currencies used throughout the world.  
Unless changed in the request, the currency is the default associated with your provisioned PCC from Travelport.  
For Hotel: SourceCurrency is based on the location of the hotel and used for all rates in the response. TargetCurrency is the currency code sent in the request in requestedCurrency.

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency.value` (string)
    An ISO 4217 currency code.
    Example: USD

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency.codeAuthority` (string)
    Currency code authority
    Example: ISO 4217

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency.decimalPlace` (integer)
    Number of decimal places for the currency.
    Example: 2

  - `OfferHospitalityResponse.CurrencyRateConversion.SourceCurrency.decimalAuthority` (string)
    Currency code decimal authority
    Example: ISO 4217

  - `OfferHospitalityResponse.CurrencyRateConversion.ConversionRate` (object, required)
    Conversion rate of SourceCurrency value to TargetCurrency value. This value can be used to calculate, independently of the API, conversion for the rates in the response. The response does not convert any amounts.

  - `OfferHospitalityResponse.CurrencyRateConversion.ConversionRate.value` (number)

  - `OfferHospitalityResponse.CurrencyRateConversion.ConversionRate.rateAuthority` (string)
    Contextual rate authority
    Example: ISO 4217

  - `OfferHospitalityResponse.CurrencyRateConversion.ConversionRate.rateAsOf` (string)
    Rate as of
    Example: 2026-08-07T12:12:00Z

  - `OfferHospitalityResponse.Pagination` (object)
    Pagination object used when result sets span across a number of pages.

  - `OfferHospitalityResponse.Pagination.@type` (string, required)
    Example: Pagination

  - `OfferHospitalityResponse.Pagination.page` (integer, required)
    The current page number of the full result set
    Example: 1

  - `OfferHospitalityResponse.Pagination.pageSize` (integer, required)
    The total number of items on this page
    Example: 20

  - `OfferHospitalityResponse.Pagination.totalPages` (integer, required)
    The total number of pages in this result set
    Example: 5

  - `OfferHospitalityResponse.Pagination.totalItems` (integer, required)
    The total number of pages in this result set
    Example: 100

## Response 400:

  - `400` (unknown)
    Bad Request - 400

## Response 400 fields (application/json):

  - `@type` (string)
    Example: response

  - `transactionId` (string)
    A unique system-generated (128 bit GUID format) transaction/tracking id for a single request and response (i.e. for a single transaction) used for internal tracking and troubleshooting.  
Also known as E2ETrackingId.  
Not returned in all Hotel API responses.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `traceId` (string)
    Used in hospitality workflows to provide a unique transaction or tracking id for a single request and response.  
For Air Eligibility, returned if a custom trace ID was sent in the request header.  
For Hotel Rules, returned if a custom trace ID was sent in the request header.
    Example: TraceID_123456

  - `correlationId` (string)
    Identifier used to correlate hotel API invocations across a multi-call business flows.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `reservationStatus` (string)
    Status of reservation or offer completion.
    Enum: "Success", "Fail", "Partial", "Pending", "OnHold", "Retry", "Other"

  - `Result` (object)
    Returns the error and/or warning message information, if applicable.
See [Error Messaging](https://developer.travelport.com/docs/flights/general/error-messaging) for additional details.

  - `Result.@type` (string)
    Discriminator class Result only
    Example: Result

  - `Result.status` (string)
    The status of an error or warning
    Enum: "Not processed", "Incomplete", "Complete", "Unknown"

  - `Result.Error` (array)
    A list of error information returned at the provider level for a response.

  - `Result.Error.@type` (string, required)
    Discriminator classes Error or ErrorDetail
    Example: ErrorDetail

  - `Result.Error.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `Result.Error.Message` (string)
    The Travelport standardized error or warning message
    Example: No flights found.

  - `Result.Error.NameValuePair` (array)

  - `Result.Error.NameValuePair.value` (string)
    Text directly related to name description, providing more detail. May have character restrictions based on remark type (e.g. Free Text limitations: 84 characters, alphanumeric and some special characters).
    Example: Sunday

  - `Result.Error.NameValuePair.id` (string)
    Optional internally referenced id
    Example: 6

  - `Result.Error.NameValuePair.name` (string, required)
    Key, categorizing the type of remark or error.
    Example: Day1

  - `Result.Error.category` (string)
    A category to assist in identifying the error
    Example: VALIDATION

  - `Result.Error.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `Result.Error.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `Result.Error.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `Result.Warning` (array)
    A list of warning information returned at the provider level for a response.

  - `Result.Warning.@type` (string, required)
    Discriminator classes Warning or WarningDetail
    Example: WarningDetail

  - `Result.Warning.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `Result.Warning.Message` (string)
    The Travelport standardized error or warning message
    Example: Customer Loyalty could not be applied.

  - `Result.Warning.NameValuePair` (array)

  - `Result.Warning.category` (string)
    A category to assist in identifying the error
    Example: INFORMATION

  - `Result.Warning.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `Result.Warning.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `Result.Warning.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `Identifier` (object)
    A globally unique identifier key often used to reference a given option (such as Pricing, Booking, Rules, or additional workflows) or to retrieve information (such as Hotel pagination).

  - `Identifier.value` (string)
    Unique offer identifier that can be sent in subsequent payload requests to reference this offer.
When used for reference flight calls, the CatalogProductOfferingsIdentifier will be the transaction identifier from the Search, Next Leg Search, or Flight Specific Search response in CatalogProductOfferings/Identifier/value.
If you choose to pull the CatalogProductOfferingsIdentifier from the Price response instead (OfferListResponse/Identifier/value), either full or reference payload, please note for subsequent Add Offer requests you must remove the _PC appended to the end of the value in the AirPrice response (e.g., change value: '93d2091d-3d04-48ab-8091-6ae1525f02ea_PC' to value: '93d2091d-3d04-48ab-8091-6ae1525f02ea').
When building an AirPrice or Add Offer reference payload request:
- Look for the CatalogProductOfferingIdentifier (ex: o1) in a Search response at CatalogProductOfferings/CatalogProductOffering/id or a Price response at OfferListResponse/OfferID/id.
- Look for the ProductIdentifier (ex: p0) in a Search response at CatalogProductOfferings/CatalogProductOffering/ProductBrandOptions/ProductBrandOffering/Product/productRef or from a Price response at OfferListResponse/OfferID/Product/id.

When returned from a workbench, this value is the system generated workbench identifier that must be sent in all subsequent requests for this workbench session.
When returned from Air Exchange Eligibility, value is the ticket number sent with the eligibility request.
When used specifically for form of payment, the value will begin with the characters 'FOP'. Similarly, the OfferIdentifier associated will begin with the character 'O'.
- If not available, for Payment, any unique identifier can be sent.

For Hotel Create Reservation (Reference Payload), send the value from the Availability response in CatalogOffering/id or the value from SearchComplete returned in propertyItems/lowestPublicAvailableRate/rateKey/value.
Results from Hotel Availability and Hotel SearchComplete are stored in the cache for 30 minutes. If the offers expire before booking, you must send a new request.
    Example: A0656EFF-FAF4-456F-B061-0161008D7C4E

  - `Identifier.authority` (string)
    Name of the supplier system that created this identifier - the source of information.  
For AirPrice, please note that GDS offers return the value 'Travelport' in authority while NDC offers return the carrier code of the issuing NDC carrier.  
When returned from Air Exchange Eligibility, authority is always 'Travelport' as the transaction issuer.  
For Hotels, authority indicates which supplier returned the lowest available rate for that property: either 'TVPT' (Travelport) or 'BKNG' (booking.com). Booking.com access requires additional provisioning and a direct agreement with the supplier. Authority is not returned if the property is closed or returns an error.  
For Hotel Create Reservation (Full Payload) and Sync Reservation send the value from the Availability response in CatalogOffering/Identifier/authority for the instance you want to book.
    Example: TVPT

  - `NextSteps` (object)
    Container for the steps that describe actions that may be taken on the containing object.  
Not applicable for an Eligibility or Exchange response.

  - `NextSteps.baseURI` (string, required)
    The base portion of the URI in order to shorten the uris in the individual steps
    Example: www.travelport.com

  - `NextSteps.id` (string)
    Optional internally referenced id
    Example: 5

  - `NextSteps.NextStep` (array, required)

  - `NextSteps.NextStep.value` (string)
    Example: www.resourcelocation.com

  - `NextSteps.NextStep.id` (string)
    Identifier for the Next Step
    Example: 2

  - `NextSteps.NextStep.action` (string, required)
    The action this next step is intended to achieve
    Example: cancel

  - `NextSteps.NextStep.method` (string, required)
    Describes the set of potential methods that can be taken after an operation.
    Enum: "GET", "DELETE", "PUT", "POST"

  - `NextSteps.NextStep.description` (string)
    Additional clarification for the next step
    Example: remove offer from the order

  - `ReferenceList` (array)

  - `ReferenceList.@type` (string, required)
    Discriminator
- Air Search child classes are ReferenceListAmenity, ReferenceListBrand, ReferenceListFlight, ReferenceListProduct, ReferenceListTermsAndConditions, and ReferenceListUniversalProductAttribute.
- Air Price child classes are ReferenceListAmenity and ReferenceListBrand.
- FareRules child class is ReferenceListFlight.
- Search Ancillaries child class is ReferenceListFlight.
- Seat Map child class is ReferenceListSeatingChart.
- Hotel Availability child class is ReferenceListPropertyDates.
- Reservation and Reservation Workbench child classes are ReferenceListAmenity, ReferenceListBrand, and ReferenceListUniversalProductAttribute.
- Exchange Search child classes are ReferenceListBrand, ReferenceListFlight, and ReferenceListExchangedPrice.
- Reservation Receipt child classes are ReferenceListOffer and ReferenceListTraveler.
- Book_Traveler child class is ReferenceListTraveler.
    Example: ReferenceListFlight

  - `ReferenceList.id` (string)
    Uniquely identifies for the Reference List
    Example: referenceList_001

  - `ReferenceList.PropertyDates` (array, required)

  - `ReferenceList.PropertyDates.@type` (string)

  - `ReferenceList.PropertyDates.availability` (string)
    Indicates whether the property has rooms available for the requested dates.
    Enum: "Open", "Close", "ClosedOnArrival", "ClosedOnArrivalOnRequest", "OnRequest", "RemoveCloseOnly", "Other"

  - `ReferenceList.PropertyDates.adaCompliant` (string)
    Yes , No , Unknown
    Enum: "Yes", "No", "Unknown"

  - `ReferenceList.PropertyDates.id` (string, required)
    Key to matching the common information in ReferenceList with an Offer; corresponds to the propertyDatesRef value in each Offer/Products/Product.

  - `ReferenceList.PropertyDates.moreRatesToken` (string)
    More rates token

  - `ReferenceList.PropertyDates.propertyName` (string)
    Name of property offering these products.

  - `ReferenceList.PropertyDates.PropertyAddress` (object)
    The property or billing address information.  
For Flights Add Traveler sending Address is optional, but when sent it must have the role set to 'Delivery' and include at least one of its objects, such as Number or City.

  - `ReferenceList.PropertyDates.PropertyAddress.@type` (string, required)
    Discriminator classes Address or AddressDetail
    Example: AddressDetail

  - `ReferenceList.PropertyDates.PropertyAddress.id` (string)
    unique address id
    Example: Address_1

  - `ReferenceList.PropertyDates.PropertyAddress.BldgRoom` (object)
    Address with building and room number

  - `ReferenceList.PropertyDates.PropertyAddress.BldgRoom.value` (string)
    Example: Moore House

  - `ReferenceList.PropertyDates.PropertyAddress.BldgRoom.buldingInd` (boolean)
    When true, the information is a building name. When false, it is an apartment or room #
    Example: true

  - `ReferenceList.PropertyDates.PropertyAddress.Number` (object)
    The street number alone is the numerical number that precedes the street name in the address.

  - `ReferenceList.PropertyDates.PropertyAddress.Number.value` (string)
    Street number value.
    Example: 23B

  - `ReferenceList.PropertyDates.PropertyAddress.Number.streetNmbrSuffix` (string)
    Street Number Suffix
    Example: B

  - `ReferenceList.PropertyDates.PropertyAddress.Number.streetDirection` (string)
    Direction of the Street
    Example: NW

  - `ReferenceList.PropertyDates.PropertyAddress.Number.ruralRouteNmbr` (string)
    RuralRoute Number
    Example: 76

  - `ReferenceList.PropertyDates.PropertyAddress.Number.po_Box` (string)
    PO Box Number
    Example: 1001

  - `ReferenceList.PropertyDates.PropertyAddress.Street` (string)
    Street name. May also contain the street number when the Number element is missing.
    Example: ABC Street

  - `ReferenceList.PropertyDates.PropertyAddress.AddressLine` (array)
    Property street address. Used in place of Street and Number. Each element of the array represents an address line.

  - `ReferenceList.PropertyDates.PropertyAddress.City` (string, required)
    Full name of the city, town, or postal station (i.e., a postal service territory, often used in a military address).
    Example: Dublin

  - `ReferenceList.PropertyDates.PropertyAddress.County` (string)
    County or Region Name.
    Example: Berkshire

  - `ReferenceList.PropertyDates.PropertyAddress.StateProv` (object)
    The standard code or abbreviation for the state, province, or region. May also include full length name.

  - `ReferenceList.PropertyDates.PropertyAddress.StateProv.value` (string)
    State, province, or region code needed to identify location (typically two characters).
    Example: CA

  - `ReferenceList.PropertyDates.PropertyAddress.StateProv.name` (string)
    State, province, or region name needed to identify location.
    Example: California

  - `ReferenceList.PropertyDates.PropertyAddress.Country` (object)
    Contains the information needed to identify a country.

  - `ReferenceList.PropertyDates.PropertyAddress.Country.value` (string)
    The ISO 3166 code for the property's address.
    Example: US

  - `ReferenceList.PropertyDates.PropertyAddress.Country.id` (string)
    Custom user-assigned identifier for the country.
    Example: 23

  - `ReferenceList.PropertyDates.PropertyAddress.Country.name` (string)
    The full name of the country for the property's address.
    Example: United States

  - `ReferenceList.PropertyDates.PropertyAddress.Country.codeContext` (string)
    The source of a code, such as the organization that provided the id number
    Example: IATA

  - `ReferenceList.PropertyDates.PropertyAddress.PostalCode` (string)
    Postal code for the address.
    Example: Sl6 1AB

  - `ReferenceList.PropertyDates.PropertyAddress.Addressee` (string)
    The name of the company or person to be addressed
    Example: ACME INC

  - `ReferenceList.PropertyDates.PropertyAddress.role` (string)
    Defines the type of location the address is assigned to. For TravelAgency address leave blank or use "Other".
    Enum: "Home", "Business", "Mailing", "Delivery", "Destination", "Other", "Billing"

  - `ReferenceList.PropertyDates.PropertyAddress.addressType` (string)
    OTA code for address type
    Example: CLT

  - `ReferenceList.PropertyDates.PropertyAddress.use` (string)
    OTA code for address use
    Example: AUT

  - `ReferenceList.PropertyDates.PropertyAddress.Comment` (object)
    Textual information.

  - `ReferenceList.PropertyDates.PropertyAddress.Comment.value` (string)
    Actual text.
May be restricted based on the type of comment. Ex:
- Notepad remarks: limited to 87 characters.
- Traveler name remarks: limited to 33 characters, only spaces and hyphens allowed for special characters.
    Example: Additional comments

  - `ReferenceList.PropertyDates.PropertyAddress.Comment.id` (string)
    Local identifier within a given message for this object.
    Example: comment_1

  - `ReferenceList.PropertyDates.PropertyAddress.Comment.name` (string)
    Title of comment or type of remark.
    Example: Comment name

  - `ReferenceList.PropertyDates.PropertyAddress.Comment.language` (string)
    Language code using ISO-639 standard
    Example: EN

  - `ReferenceList.PropertyDates.PropertyAddress.Privacy` (object)
    Confidential details for marketing purpose

  - `ReferenceList.PropertyDates.PropertyAddress.Privacy.id` (string)
    Optional internally referenced id
    Example: 2

  - `ReferenceList.PropertyDates.PropertyAddress.Privacy.shareMarketing` (string)
    Used to indicate marketing preferences, Yes, No, Inherit
    Enum: "Yes", "No", "Inherit"

  - `ReferenceList.PropertyDates.PropertyAddress.Privacy.optInStatus` (string)
    Used to indicate marketing preferences, OptIn, OptOut
    Enum: "OptedIn", "OptedOut", "Unknown"

  - `ReferenceList.PropertyDates.PropertyAddress.Privacy.optInDate` (string)
    The datetime of receiving the opt in notice
    Example: 2026-08-07T12:12:00Z

  - `ReferenceList.PropertyDates.PropertyAddress.Privacy.optOutDate` (string)
    The datetime the opt out notice was received
    Example: 2026-08-07T12:12:00Z

  - `ReferenceList.PropertyDates.PropertyAddress.Priority` (integer)
    The priority ranking within the group
    Example: 1

  - `ReferenceList.PropertyDates.PropertyAddress.validInd` (boolean)
    If true, this is a valid and complete mailing address that has been verified through an address verification service or previously mailed materials have not been returned.
    Example: false

  - `ReferenceList.PropertyDates.PropertyAddress.provisionedInd` (boolean)
    If true, this address came into the system through provisioning
    Example: false

  - `ReferenceList.PropertyDates.PropertyKey` (object, required)
    Contains up to 250 PropertyKey objects. Each PropertyKey object identifies one property.

  - `ReferenceList.PropertyDates.PropertyKey.@type` (string)

  - `ReferenceList.PropertyDates.PropertyKey.chainCode` (string, required)
    Code for the hotel chain (typically 2 characters)
    Example: UR

  - `ReferenceList.PropertyDates.PropertyKey.propertyCode` (string, required)
    The property code of the requested property (typically 5 characters).
    Example: G3375

  - `ReferenceList.PropertyDates.DateRange` (object, required)
    Specifies the begin and end date of an event, such as check-in and check-out dates.

  - `ReferenceList.PropertyDates.DateRange.start` (string, required)
    Specifies the start date for an event, such as a booking or check-in date in YYYY-MM-DD format.
    Example: 2026-03-03

  - `ReferenceList.PropertyDates.DateRange.end` (string, required)
    Specifies the end date an event, such as a booking or check-out date in YYYY-MM-DD format.
    Example: 2026-03-03

  - `ReferenceList.PropertyDates.GeoLocation` (object)
    For Hotel: the geographic coordinates of the property.

  - `ReferenceList.PropertyDates.GeoLocation.latitude` (number, required)
    Numeric value representing latitude of search center point in degrees and decimal minutes.
    Example: 38.8951

  - `ReferenceList.PropertyDates.GeoLocation.longitude` (number, required)
    Numeric value representing longitude of search center point in degrees and decimal minutes.
    Example: -77.0364

  - `ReferenceList.PropertyDates.GeoLocation.altitude` (number)
    The height of a location, typically measured above sea level
    Example: 5280

  - `ReferenceList.PropertyDates.GeoLocation.altitudeUnitOfDistance` (string)
    For Hotels: Optional object to request either miles or kilometers for the search radius from the specified location. If unitOfDistance is not specified, the search defaults to miles for properties in the United States, Myanmar, and Liberia. The search defaults to kilometers in all other countries.
    Enum: "Miles", "Kilometers"

  - `ReferenceList.PropertyDates.GeoLocation.positionAccuracy` (string)
    Specifies the level of accuracy for the position
    Enum: "Zip9Code", "Zip7Code", "Zip5Code", "Street", "State", "Property", "Intersection", "Exact", "County", "City", "Block"

  - `ReferenceList.PropertyDates.GeoLocation.mapURL` (string)
    link for embedded map showing location
    Example: www.destinationmap.com

  - `ReferenceList.PropertyDates.GeoLocation.formatURL` (string)
    The URL to the format for the latitude and longitude for this location.
    Example: www.destinationmap.com

  - `ReferenceList.PropertyDates.Telephone` (object)
    Phone information for contacting the relevant individual or agency.  
For Flights Add Traveler, NDC carriers typically require either an email address or phone number for booking. Recommended best practice is to provide both Email and Telephone for NDC.

  - `ReferenceList.PropertyDates.Telephone.@type` (string, required)
    Discriminator classes Telephone or TelephoneDetail
    Example: Telephone

  - `ReferenceList.PropertyDates.Telephone.countryAccessCode` (string)
    Phone country code
    Example: 1

  - `ReferenceList.PropertyDates.Telephone.areaCityCode` (string)
    Phone local area code
    Example: 972

  - `ReferenceList.PropertyDates.Telephone.phoneNumber` (string, required)
    Mobile/Telephone Number. Accepted characters are numeric, dash, space, and period.
    Example: 972-000-787

  - `ReferenceList.PropertyDates.Telephone.extension` (string)
    Telephone extension number
    Example: 234

  - `ReferenceList.PropertyDates.Telephone.id` (string)
    Optional custom user-assigned identifier for a phone number.
    Example: 3

  - `ReferenceList.PropertyDates.Telephone.cityCode` (string)
    IATA city code if referenced by phone number.
    Example: DEN

  - `ReferenceList.PropertyDates.Telephone.role` (string)
    Defines the type of location the Telephone is assigned to. For Travel Agency telephone select "Other" or leave blank.
    Enum: "Mobile", "Home", "Work", "Office", "Fax", "Other"

  - `ReferenceList.PropertyDates.Telephone.phoneLocationType` (string)
    Location of the phone
    Example: Agency

  - `ReferenceList.PropertyDates.Telephone.phoneTechType` (string)
    Indicates the type of technology associated with the telephone number
    Example: Voice

  - `ReferenceList.PropertyDates.Telephone.phoneUseType` (string)
    Agency code for how phone is used (e.g., Home, Business, Emergency Contact, Travel Arranger, Day, Evening).
    Example: Home

  - `ReferenceList.PropertyDates.Telephone.pin` (string)
    Additional codes used for telephone
    Example: 3456

  - `ReferenceList.PropertyDates.Telephone.priority` (integer)
    Priority
    Example: 1

  - `ReferenceList.PropertyDates.Telephone.defaultInd` (boolean)
    When true, indicates a default value should be used.
    Example: true

  - `ReferenceList.PropertyDates.Telephone.provisionedInd` (boolean)
    true indicates this phone number was created through provisioned
    Example: false

  - `ReferenceList.PropertyDates.Email` (object)
    Electronic email addresses, in IETF specified format.  
Booking.com requires a traveler email address in the Hotel Create Reservation and Add Reservation requests. A system-generated confirmation email is sent to the traveler after the booking completes.
For Flights Add Traveler, NDC carriers typically require either an email address or phone number for booking. Recommended best practice is to provide both Email and Telephone for NDC.

  - `ReferenceList.PropertyDates.Email.value` (string)
    The email address.
    Example: exampledomain@example.com

  - `ReferenceList.PropertyDates.Email.id` (string)
    Electronic email addresses, in IETF specified format.
    Example: email_1

  - `ReferenceList.PropertyDates.Email.emailType` (string)
    Use email type to specify if the email is to be sent "TO" or sent "FROM"
    Example: FROM

  - `ReferenceList.PropertyDates.Email.comment` (string)
    Any freeform note for the email, such as its purpose.
    Example: work email

  - `ReferenceList.PropertyDates.Email.preferredFormat` (string)
    Mime media type
    Example: text/html

  - `ReferenceList.PropertyDates.Email.optInDate` (string)
    The datetime of receiving the opt in notice
    Example: 2026-03-03T11:11:00Z

  - `ReferenceList.PropertyDates.Email.optOutDate` (string)
    The datetime the opt out notice was received
    Example: 2026-03-03T11:11:00Z

  - `ReferenceList.PropertyDates.Email.validInd` (boolean)
    If true, this is a valid email address that has been system verified via a successful email transmission.
    Example: true

  - `ReferenceList.PropertyDates.Email.provisionedInd` (boolean)
    If true then the email address came from the provisioning process
    Example: true

  - `CurrencyRateConversion` (array)

  - `CurrencyRateConversion.@type` (string)

  - `CurrencyRateConversion.SourceCurrency` (object, required)
    Currency codes are the three-letter alphabetic codes that represent the various currencies used throughout the world.  
Unless changed in the request, the currency is the default associated with your provisioned PCC from Travelport.  
For Hotel: SourceCurrency is based on the location of the hotel and used for all rates in the response. TargetCurrency is the currency code sent in the request in requestedCurrency.

  - `CurrencyRateConversion.SourceCurrency.value` (string)
    An ISO 4217 currency code.
    Example: USD

  - `CurrencyRateConversion.SourceCurrency.codeAuthority` (string)
    Currency code authority
    Example: ISO 4217

  - `CurrencyRateConversion.SourceCurrency.decimalPlace` (integer)
    Number of decimal places for the currency.
    Example: 2

  - `CurrencyRateConversion.SourceCurrency.decimalAuthority` (string)
    Currency code decimal authority
    Example: ISO 4217

  - `CurrencyRateConversion.ConversionRate` (object, required)
    Conversion rate of SourceCurrency value to TargetCurrency value. This value can be used to calculate, independently of the API, conversion for the rates in the response. The response does not convert any amounts.

  - `CurrencyRateConversion.ConversionRate.value` (number)

  - `CurrencyRateConversion.ConversionRate.rateAuthority` (string)
    Contextual rate authority
    Example: ISO 4217

  - `CurrencyRateConversion.ConversionRate.rateAsOf` (string)
    Rate as of
    Example: 2026-08-07T12:12:00Z

  - `Pagination` (object)
    Pagination object used when result sets span across a number of pages.

  - `Pagination.@type` (string, required)
    Example: Pagination

  - `Pagination.page` (integer, required)
    The current page number of the full result set
    Example: 1

  - `Pagination.pageSize` (integer, required)
    The total number of items on this page
    Example: 20

  - `Pagination.totalPages` (integer, required)
    The total number of pages in this result set
    Example: 5

  - `Pagination.totalItems` (integer, required)
    The total number of pages in this result set
    Example: 100

## Response 401:

  - `401` (unknown)
    Unauthorized - 401

## Response 401 fields (application/json):

  - `@type` (string)
    Example: response

  - `transactionId` (string)
    A unique system-generated (128 bit GUID format) transaction/tracking id for a single request and response (i.e. for a single transaction) used for internal tracking and troubleshooting.  
Also known as E2ETrackingId.  
Not returned in all Hotel API responses.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `traceId` (string)
    Used in hospitality workflows to provide a unique transaction or tracking id for a single request and response.  
For Air Eligibility, returned if a custom trace ID was sent in the request header.  
For Hotel Rules, returned if a custom trace ID was sent in the request header.
    Example: TraceID_123456

  - `correlationId` (string)
    Identifier used to correlate hotel API invocations across a multi-call business flows.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `reservationStatus` (string)
    Status of reservation or offer completion.
    Enum: "Success", "Fail", "Partial", "Pending", "OnHold", "Retry", "Other"

  - `Result` (object)
    Returns the error and/or warning message information, if applicable.
See [Error Messaging](https://developer.travelport.com/docs/flights/general/error-messaging) for additional details.

  - `Result.@type` (string)
    Discriminator class Result only
    Example: Result

  - `Result.status` (string)
    The status of an error or warning
    Enum: "Not processed", "Incomplete", "Complete", "Unknown"

  - `Result.Error` (array)
    A list of error information returned at the provider level for a response.

  - `Result.Error.@type` (string, required)
    Discriminator classes Error or ErrorDetail
    Example: ErrorDetail

  - `Result.Error.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `Result.Error.Message` (string)
    The Travelport standardized error or warning message
    Example: No flights found.

  - `Result.Error.NameValuePair` (array)

  - `Result.Error.NameValuePair.value` (string)
    Text directly related to name description, providing more detail. May have character restrictions based on remark type (e.g. Free Text limitations: 84 characters, alphanumeric and some special characters).
    Example: Sunday

  - `Result.Error.NameValuePair.id` (string)
    Optional internally referenced id
    Example: 6

  - `Result.Error.NameValuePair.name` (string, required)
    Key, categorizing the type of remark or error.
    Example: Day1

  - `Result.Error.category` (string)
    A category to assist in identifying the error
    Example: VALIDATION

  - `Result.Error.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `Result.Error.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `Result.Error.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `Result.Warning` (array)
    A list of warning information returned at the provider level for a response.

  - `Result.Warning.@type` (string, required)
    Discriminator classes Warning or WarningDetail
    Example: WarningDetail

  - `Result.Warning.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `Result.Warning.Message` (string)
    The Travelport standardized error or warning message
    Example: Customer Loyalty could not be applied.

  - `Result.Warning.NameValuePair` (array)

  - `Result.Warning.category` (string)
    A category to assist in identifying the error
    Example: INFORMATION

  - `Result.Warning.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `Result.Warning.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `Result.Warning.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `Identifier` (object)
    A globally unique identifier key often used to reference a given option (such as Pricing, Booking, Rules, or additional workflows) or to retrieve information (such as Hotel pagination).

  - `Identifier.value` (string)
    Unique offer identifier that can be sent in subsequent payload requests to reference this offer.
When used for reference flight calls, the CatalogProductOfferingsIdentifier will be the transaction identifier from the Search, Next Leg Search, or Flight Specific Search response in CatalogProductOfferings/Identifier/value.
If you choose to pull the CatalogProductOfferingsIdentifier from the Price response instead (OfferListResponse/Identifier/value), either full or reference payload, please note for subsequent Add Offer requests you must remove the _PC appended to the end of the value in the AirPrice response (e.g., change value: '93d2091d-3d04-48ab-8091-6ae1525f02ea_PC' to value: '93d2091d-3d04-48ab-8091-6ae1525f02ea').
When building an AirPrice or Add Offer reference payload request:
- Look for the CatalogProductOfferingIdentifier (ex: o1) in a Search response at CatalogProductOfferings/CatalogProductOffering/id or a Price response at OfferListResponse/OfferID/id.
- Look for the ProductIdentifier (ex: p0) in a Search response at CatalogProductOfferings/CatalogProductOffering/ProductBrandOptions/ProductBrandOffering/Product/productRef or from a Price response at OfferListResponse/OfferID/Product/id.

When returned from a workbench, this value is the system generated workbench identifier that must be sent in all subsequent requests for this workbench session.
When returned from Air Exchange Eligibility, value is the ticket number sent with the eligibility request.
When used specifically for form of payment, the value will begin with the characters 'FOP'. Similarly, the OfferIdentifier associated will begin with the character 'O'.
- If not available, for Payment, any unique identifier can be sent.

For Hotel Create Reservation (Reference Payload), send the value from the Availability response in CatalogOffering/id or the value from SearchComplete returned in propertyItems/lowestPublicAvailableRate/rateKey/value.
[...]
